<?php
/*******************************************************************************
* SC Light  2012-2013, Bugo		                   	                       *
********************************************************************************
* Subs-SCL.php														           *
********************************************************************************
* License http://creativecommons.org/licenses/by-nc-nd/3.0/deed.ru CC BY-NC-ND *
* Support and updates for this software can be found at	http://dragomano.ru    *
*******************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function scl_load_theme()
{
	loadLanguage('SCL');
}

function scl_menu_buttons(&$buttons)
{
	global $modSettings, $txt, $scripturl;
	
	$counter = isset($buttons['forum']) ? 2 : 1;
	
	$buttons = array_merge(
		array_slice($buttons, 0, $counter, true),
		array(
			'scl' => array(
				'title' => !empty($modSettings['scl_menu_item']) ? $modSettings['scl_menu_item'] : $txt['scl_menu'],
				'href' => $scripturl . '?action=scl',
				'show' => true,
				'sub_buttons' => array(
					'settings' => array(
						'title' => $txt['settings'],
						'href' => $scripturl . '?action=admin;area=modsettings;sa=scl',
						'show' => allowedTo('admin_forum'),
						'is_last' => true
					),
				),
			),
		),
		array_slice($buttons, $counter, null, true)
	);
}

function scl_actions(&$actionArray)
{
	$actionArray['scl'] = array('Subs-SCL.php', 'scl_main');
}

function scl_main()
{
	global $context, $modSettings, $txt, $sourcedir, $scripturl;
	
	loadTemplate('SCL', 'scl');
	
	$context['page_title'] = $txt['scl'];
	$context['canonical_url'] = $scripturl . '?action=scl';
	
	$context['linktree'][] = array(
		'name' => $context['page_title'],
		'url' => $scripturl . '?action=scl'
	);

	scl_data();
}

function scl_data()
{
	global $context, $txt, $scripturl, $txt, $modSettings, $sourcedir;
	
	if (empty($modSettings['scl_mode']))
		fatal_lang_error('scl_offmode', false);
		
	$context['template_layers'][] = 'scl';
	$context['can_post_new'] = true;
	$context['show_thumbnails'] = false;
	$context['sel_category'] = scl_get_catname();
	
	$listOptions = array(
		'id' => 'bbs_list',
		'items_per_page' => $modSettings['scl_items_per_page'],
		'title' => '',
		'no_items_label' => $txt['scl_empty'],
		'base_href' => $scripturl . '?action=scl',
		'default_sort_col' => 'date',
		'get_items' => array(
			'function' => 'list_getBbsEntries',
		),
		'get_count' => array(
			'function' => 'list_getNumBbsEntries',
		),
		'columns' => array(
			'icon' => array(
				'header' => array(
					'value' => '',
				),
				'data' => array(
					'function' => create_function('$entry', '
						return \'<img src="\' . $entry[\'icon_url\'] . \'" alt="" />\';
					'),
					'style' => 'text-align: center;',
				),
			),
			'date' => array(
				'header' => array(
					'value' => $txt['date'],
				),
				'data' => array(
					'db' => 'date',
					'style' => 'text-align: center;',
				),
				'sort' => array(
					'default' => 'm.poster_time DESC',
					'reverse' => 'm.poster_time',
				),
			),
			'section' => array(
				'header' => array(
					'value' => $txt['board'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl;
							return \'<a href="\' . $scripturl . \'?board=\' . $entry[\'board\'] . \'.0" target="_blank">\' . $entry[\'name\'] . \'</a>\';
					'),
				),
				'sort' => array(
					'default' => 'b.name',
					'reverse' => 'b.name DESC',
				),
			),
			'title' => array(
				'header' => array(
					'value' => $txt['topic'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt, $settings;
							return \'<a href="\' . $scripturl . \'?topic=\' . $entry[\'id\'] . \'.0" target="_blank"\' . (!$entry[\'approved\'] ? \' class="approvetbg2"\' : \'\') . \'>\' . ($entry[\'is_sticky\'] ? \'<strong>\' : \'\') . $entry[\'title\'] . ($entry[\'is_sticky\'] ? \'</strong>\' : \'\') . \'</a>\' . ($entry[\'is_new\'] ? \'&nbsp;<a href="\' . $entry[\'new_href\'] . \'" id="newicon\' . $entry[\'msg\'] . \'" class="css3button"><strong>\' . $txt[\'scl_new\'] . \'</strong></a>\' : \'\') . (!$entry[\'approved\'] ? \'<br /><span class="smalltext"><small>\' . $txt[\'scl_not_approved\'] . \'</small></span>\' : \'\') . \'&nbsp;\';
					'),
				),
				'sort' => array(
					'default' => 'm.subject',
					'reverse' => 'm.subject DESC',
				),
			),
			'user' => array(
				'header' => array(
					'value' => $txt['author'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl;
							return empty($entry[\'user\']) ? $entry[\'poster\'] : \'<a href="\' . $scripturl . \'?action=profile;u=\' . $entry[\'user\'] . \'" target="_blank">\' . $entry[\'poster\'] . \'</a>\';
					'),
					'style' => 'text-align: center;',
				),
				'sort' => array(
					'default' => 'poster',
					'reverse' => 'poster DESC',
				),
			),
		),
		'form' => array(
			'href' => $scripturl . '?action=scl',
			'include_sort' => true,
			'include_start' => true,
			'hidden_fields' => array(
				$context['session_var'] => $context['session_id']
			),
		),
		'additional_rows' => array(
			array(
				'position' => 'after_title',
				'value' => !empty($context['sel_category']) ? $txt['scl_info'] . '<br />' . sprintf($txt['scl_hint'], $context['sel_category']) : $txt['scl_info'],
				'class' => 'smalltext',
				'style' => 'padding: 0;',
			),
		),
	);
	
	// Other columns
	if (boardsAllowedTo('view_attachments'))
		$listOptions['columns']['image'] = array(
			'header' => array(
				'value' => $txt['scl_image'],
			),
			'data' => array(
				'function' => create_function('$entry', '
					global $txt, $context;
					$temp = $txt[\'no\'];
					if ($context[\'show_thumbnails\'])
					{
						$imagefound = false;

						foreach ($entry[\'image\'] as $image)
						{
							if ($imagefound == true)
								break;

							if (isset($image[\'id\']))
							{
								$temp = \'<a id="link_\' . ($image[\'id\'] - 1) . \'" class="highslide" onclick="if (window.hs) return hs.expand(this, { slideshowGroup: 14})" href="\' . $image[\'link\'] . \'"><img src="\' . $image[\'url\'] . \'" height="\' . $image[\'height\'] . \'" alt="" /></a>\';
								$imagefound = true;
							}
						}
					}
					return $temp;
				'),
				'style' => 'text-align: center;',
			),
		);
		
	$listOptions['columns']['replies'] = array(
		'header' => array(
			'value' => $txt['replies'],
		),
		'data' => array(
			'db' => 'replies',
			'style' => 'text-align: center;',
		),
		'sort' => array(
			'default' => 't.num_replies',
			'reverse' => 't.num_replies DESC',
		),
	);
	
	$listOptions['columns']['views'] = array(
		'header' => array(
			'value' => $txt['views'],
		),
		'data' => array(
			'db' => 'views',
			'style' => 'text-align: center;',
		),
		'sort' => array(
			'default' => 't.num_views',
			'reverse' => 't.num_views DESC',
		),
	);
	
	// Action column
	$listOptions['columns']['actions'] = array(
		'header' => array(),
		'data' => array(
			'function' => create_function('$entry', '
				global $scripturl, $txt, $settings, $context;
				return (!$entry[\'approved\'] ? \'<a href="\' . $scripturl . \'?action=moderate;area=postmod;sa=approve;topic=\' . $entry[\'id\'] . \'.0;msg=\' . $entry[\'msg\'] . \';\' . $context[\'session_var\'] . \'=\' . $context[\'session_id\'] . \'" onclick="return confirm(\' . JavaScriptEscape($txt[\'quickmod_confirm\']) . \')"><img title="\' . $txt[\'approve\'] . \'" alt="\' . $txt[\'approve\'] . \'" src="\' . $settings[\'default_images_url\'] . \'/sc_light/approve.png" /></a>\' : \'\') . (allowedTo(\'admin_forum\') || allowedTo(\'moderate_forum\') ? \'
				<a href="\' . $scripturl . \'?action=movetopic;topic=\' . $entry[\'id\'] . \'.0" onclick="return confirm(\' . JavaScriptEscape($txt[\'quickmod_confirm\']) . \')"><img title="\' . $txt[\'move_topic\'] . \'" alt="\' . $txt[\'move_topic\'] . \'" src="\' . $settings[\'default_images_url\'] . \'/sc_light/move.png" /></a>\' : \'\') . 
				(allowedTo(\'admin_forum\') || allowedTo(\'moderate_forum\') || $entry[\'is_own\'] ? \'<a href="\' . $scripturl . \'?action=post;msg=\' . $entry[\'msg\'] . \';topic=\' . $entry[\'id\'] . \'.0" onclick="return confirm(\' . JavaScriptEscape($txt[\'quickmod_confirm\']) . \')"><img title="\' . $txt[\'modify\'] . \'" alt="\' . $txt[\'modify\'] . \'" src="\' . $settings[\'default_images_url\'] . \'/sc_light/edit.png" /></a>
				<a href="\' . $scripturl . \'?action=removetopic2;topic=\' . $entry[\'id\'] . \'.0;\' . $context[\'session_var\'] . \'=\' . $context[\'session_id\'] . \'" onclick="return confirm(\' . JavaScriptEscape($txt[\'quickmod_confirm\']) . \')"><img title="\' . $txt[\'delete\'] . \'" alt="\' . $txt[\'delete\'] . \'" src="\' . $settings[\'default_images_url\'] . \'/sc_light/delete.png" /></a>\' : \'\');
			'),
			'class' => 'scl_actions',
		)
	);

	require_once($sourcedir . '/Subs-List.php');
	createList($listOptions);

	$context['sub_template'] = 'show_list';
	$context['default_list'] = '';	
	if (empty($context['sel_category'])) return;

	$context['default_list'] = 'bbs_list';
	scl_board_list();
}

function scl_get_catname()
{
	global $smcFunc, $modSettings;
	
	if (empty($modSettings['scl_category'])) return;
	
	$request = $smcFunc['db_query']('', '
		SELECT name
		FROM {db_prefix}categories
		WHERE id_cat = {int:cat}',
		array(
			'cat' => (int) $modSettings['scl_category']
		)
	);
	
	list ($name) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);
	
	return $name;
}

function scl_board_list()
{
	global $modSettings, $context, $smcFunc, $sourcedir, $scripturl, $txt;
	
	if (empty($modSettings['scl_category'])) return;
	
	$request = $smcFunc['db_query']('', '
		SELECT id_board
		FROM {db_prefix}boards
		WHERE id_cat = {int:sel_cat}',
		array(
			'sel_cat' => (int) $modSettings['scl_category']
		)
	);
	
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$included_boards[] = $row['id_board'];

	$smcFunc['db_free_result']($request);

	if (empty($included_boards)) return;

	require_once($sourcedir . '/Subs-MessageIndex.php');
	
	$boardListOptions = array(
		'included_boards' => $included_boards,
		'ignore_boards' => true,
		'use_permissions' => true,
		'not_redirection' => true
	);

	$context['boards'] = getBoardList($boardListOptions);
	$context['can_post_new'] = allowedTo('post_new', $included_boards) || ($modSettings['postmod_active'] && allowedTo('post_unapproved_topics', $included_boards));
}

// BBS output
function list_getBbsEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $user_info, $modSettings, $txt, $settings, $scripturl, $context;
	
	$request = $smcFunc['db_query']('', '
		SELECT
			m.id_msg, IFNULL(m.poster_time, 0) AS poster_time, m.id_msg_modified, m.subject, m.icon,
			' . ($user_info['is_guest'] ? '0' : 'IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1') . ' AS new_from,
			t.id_topic, t.id_first_msg, t.id_member_started AS user, t.approved, t.is_sticky, t.num_views, t.num_replies,
			b.id_board, b.name, IFNULL(mem.real_name, {string:guest}) AS poster,
			IFNULL(large.id_attach, 0) AS large_id, large.filename AS large_filename, large.width AS large_width, large.height AS large_height,
			IFNULL(small.id_attach, 0) AS small_id, small.filename AS small_filename, small.width AS small_width, small.height AS small_height
		FROM {db_prefix}topics AS t
			INNER JOIN {db_prefix}messages AS m ON (m.id_msg = t.id_first_msg)
			LEFT JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . ($user_info['is_guest'] ? '' : '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = t.id_topic AND lt.id_member = {int:current_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = t.id_board AND lmr.id_member = {int:current_member})') . '
			LEFT JOIN {db_prefix}attachments AS large ON (large.id_msg = m.id_msg AND large.attachment_type = 0)
			LEFT JOIN {db_prefix}attachments AS small ON (small.id_attach = large.id_thumb)
		WHERE b.id_cat = {int:cat}'	. (!$modSettings['postmod_active'] || allowedTo('approve_posts') ? '' : '
			AND (t.approved = {int:is_approved}' . ($user_info['is_guest'] ? '' : ' OR t.id_member_started = {int:current_member}') . ')') . '
			AND {query_wanna_see_board}
			AND {query_see_board}
		GROUP BY t.id_topic
		ORDER BY ' . $sort . '
		LIMIT ' . $start . ', ' . $items_per_page,
		array(
			'guest' => $txt['guest'],
			'current_member' => $user_info['id'],
			'cat' => (int) $modSettings['scl_category'],
			'is_approved' => 1,
		)
	);

	$entries = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		if ($row['small_id'] != 0)
		{
			$image = array(
				'id' => $row['small_id'],
				'url' => $scripturl . '?action=dlattach;topic=' . $row['id_topic'] . '.0;attach=' . $row['small_id'] . ';image',
				'link' => $scripturl . '?action=dlattach;topic=' . $row['id_topic'] . '.0;attach=' . $row['large_id'] . ';image',
				'filename' => $row['small_filename'],
				'height' => $modSettings['scl_thumb_height']
			);

			$context['show_thumbnails'] = true;
		}
		elseif ($row['large_id'] != 0 && $row['large_width'] > 0 && $row['large_height'] > 0)
		{
			$image = array(
				'id' => $row['large_id'],
				'url' => $scripturl . '?action=dlattach;topic=' . $row['id_topic'] . '.0;attach=' . $row['large_id'] . ';image',
				'link' => $scripturl . '?action=dlattach;topic=' . $row['id_topic'] . '.0;attach=' . $row['large_id'] . ';image',
				'filename' => $row['large_filename'],
				'width' => $row['large_width'],
				'height' => $row['large_height']
			);

			$context['show_thumbnails'] = true;
		}
		else
			$image = array();
			
		censorText($row['subject']);
			
		$entries[] = array(
			'id' => $row['id_topic'],
			'msg' => $row['id_first_msg'],
			'icon_url' => $settings[file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url'] . '/post/' . $row['icon'] . '.gif',
			'date' => timeformat($row['poster_time']),
			'board' => $row['id_board'],
			'name' => $row['name'],
			'title' => $row['subject'],
			'user' => $row['user'],
			'poster' => $row['poster'],
			'replies' => $row['num_replies'],
			'views' => $row['num_views'],
			'is_sticky' => !empty($modSettings['enableStickyTopics']) && !empty($row['is_sticky']),
			'is_new' => $row['new_from'] <= $row['id_msg_modified'],
			'new_href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['new_from'] . '#new',
			'is_own' => $row['user'] == $user_info['id'],
			'approved' => $row['approved'],
			'image' => array($image),
		);
	}
	
	$smcFunc['db_free_result']($request);

	return $entries;
}

// BBS count
function list_getNumBbsEntries()
{
	global $smcFunc, $modSettings;
	
	$request = $smcFunc['db_query']('', '
		SELECT COUNT(t.id_topic)
		FROM {db_prefix}topics AS t
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = t.id_member_started)
			LEFT JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
			LEFT JOIN {db_prefix}categories AS c ON (c.id_cat = b.id_cat)
		WHERE c.id_cat = {int:cat}',
		array(
			'cat' => (int) $modSettings['scl_category']
		)
	);
	
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

function scl_admin_areas(&$admin_areas)
{
	global $txt;
	
	$admin_areas['config']['areas']['modsettings']['subsections']['scl'] = array($txt['scl_settings']);
}

function scl_modifications(&$subActions)
{
	$subActions['scl'] = 'scl_settings';
}

function scl_settings()
{
	global $context, $txt, $scripturl, $modSettings, $smcFunc;
	
	$context['page_title'] = $txt['scl_settings'];
	$context['settings_title'] = $txt['settings'];
	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=scl';
	$context[$context['admin_menu_name']]['tab_data']['tabs']['scl'] = array('description' => $txt['scl_desc']);
	$txt['scl_no_cat'] = sprintf($txt['scl_no_cat'], $scripturl . '?action=admin;area=manageboards;sa=newcat');
	
	if (empty($modSettings['scl_items_per_page'])) updateSettings(array('scl_items_per_page' => 30));
	if (empty($modSettings['scl_thumb_height'])) updateSettings(array('scl_thumb_height' => 80));
	
	$request = $smcFunc['db_query']('', '
		SELECT id_cat, name
		FROM {db_prefix}categories
		ORDER BY cat_order',
		array()
	);
	
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$categories[$row['id_cat']] = $row['name'];

	$smcFunc['db_free_result']($request);
	
	if (empty($categories)) {
		$config_vars = array(array('desc', 'scl_no_cat'));
		$context['settings_save_dont_show'] = true;
	}
	else
		$config_vars = array(
			array('check', 'scl_mode'),
			array('text', 'scl_menu_item'),
			array('select', 'scl_category', $categories),
			array('int', 'scl_thumb_height'),
			array('int', 'scl_items_per_page')
		);
	
	// Saving?
	if (isset($_GET['save']))
	{
		checkSession();
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=modsettings;sa=scl');
	}
	
	prepareDBSettingContext($config_vars);
}

// Who is online
function scl_whos_online($actions)
{
	global $txt, $scripturl;

	$result = '';

	if (!empty($actions['action']) && $actions['action'] == 'scl')
		$result = sprintf($txt['scl_who_main'], $scripturl . '?action=scl');

	return $result;
}

// Footer
function scl_subway()
{
	$tmp = 'PGRpdiBjbGFzcz0iY2VudGVydGV4dCBzbWFsbHRleHQiPjxhIGhyZWY9Imh0dHA6Ly9kcmFnb21hbm8ucnUvcGFnZS9zYy1saWdodCIgdGFyZ2V0PSJfYmxhbmsiPlNDIExpZ2h0PC9hPiAmY29weTsgMjAxMi0yMDEzPC9kaXY+';
	
	// Link Exchange Master?
	if (function_exists('lem_output')) lem_output('', true);

	echo base64_decode($tmp);
}

?>